﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.OleDb;

namespace Estacionamento_BD
{
    class Program
    {

        public static class Access
        {
            public static OleDbConnection AbrirConexao()
            {
                return new OleDbConnection(@"Provider=Microsoft.Jet.OleDb.4.0;Data Source=E:\Sergio16GB\aulas 17\Ituiutaba\1 SEM\EC\POO\Estacionamento_BD\Estacionamento_BD\Estacionamento.mdb");                      
            }
        }

        public class Estacionamento
        {
            private string placa_veiculo { get; set; }
            private string marca_veiculo { get; set; }
            private string modelo_veiculo { get; set; }
            private string tipo_veiculo { get; set; }
            private int hora_entrada { get; set; }
            private int minuto_entrada { get; set; }
            private int hora_saida { get; set; }
            private int minuto_saida { get; set; }

            public void ZerarVaga(int qualvaga)
            {
                OleDbConnection cnn = Access.AbrirConexao();
                OleDbCommand cmd = new OleDbCommand();
                cmd.Connection = cnn;
                cmd.CommandText = "Update vagas set hora_entrada=-1,hora_saida=-1,minuto_entrada=-1,minuto_saida=-1 where numero_vaga=" + qualvaga;
                try
                {
                    cnn.Open();
                    cmd.ExecuteNonQuery();
                    cnn.Close();
                }
                catch (OleDbException e)
                {
                    Console.WriteLine("Erro: {0}", e.Errors[0].Message);
                }
            }

            public void PreencherDadosVeiculo()
            {
                int opc;
                Console.Write("Informe a placa do veículo: ");
                this.placa_veiculo = Console.ReadLine();
                Console.Write("Informe a marca do veículo: ");
                this.marca_veiculo = Console.ReadLine();
                Console.Write("Informe o modelo do veículo: ");
                this.modelo_veiculo = Console.ReadLine();
                Console.Write("Escolha:\n1 - Veículo de Passeio\n2 - Veículo Utilitário\n3 - Ônibus\n4 - Caminhão\nQual opção? ");
                do
                {
                    opc = Convert.ToInt32(Console.ReadLine());
                    if (opc < 1 || opc > 4)
                        Console.Write("Escolha:\n1 - Veículo de Passeio\n2 - Veículo Utilitário\n3 - Ônibus\n4 - Caminhão\nQual opção? ");
                    else
                    {
                        if (opc == 1)
                            this.tipo_veiculo = "passeio";
                        if (opc == 2)
                            this.tipo_veiculo = "utilitario";
                        if (opc == 3)
                            this.tipo_veiculo = "onibus";
                        if (opc == 4)
                            this.tipo_veiculo = "caminhao";
                     }
                } while(opc < 1 || opc > 4);
                //chamar método de preencher hora e minuto
                DadosEntrada();
            }

            public void DadosEntrada()
            {
                Console.Write("Digite a hora de entrada: ");
                this.hora_entrada = Convert.ToInt32(Console.ReadLine());
                Console.Write("Digite os minutos de entrada: ");
                this.minuto_entrada = Convert.ToInt32(Console.ReadLine());

            }

            public void DadosSaida()
            {
                Console.Write("Digite a hora de saída: ");
                this.hora_saida = Convert.ToInt32(Console.ReadLine());
                Console.Write("Digite os minutos de saída: ");
                this.minuto_saida = Convert.ToInt32(Console.ReadLine());
                if (this.hora_saida < this.hora_entrada)
                {
                    Console.WriteLine("A hora de entrada não pode ser maior do que a hora de saída");
                    DadosSaida();
                }
                else
                {
                    if (this.hora_saida == this.hora_entrada)
                    {
                        if (this.minuto_saida <= this.minuto_entrada)
                        {
                            Console.WriteLine("Os minutos de entrada não pode ser maior ou igual ao minuto de saída");
                            DadosSaida();
                        }
                    }
                }
               // Console.WriteLine("Saida: {0}:{1}", this.hora_saida,this.minuto_saida);
            }

            public int CalculaTempo()
            {
                int entrada;
                int saida;

                entrada = this.hora_entrada * 60 + this.minuto_entrada;
                saida = this.hora_saida * 60 + this.minuto_saida;
                return saida - entrada;
            }

            public double ValorAPagar(int tempo)
            {
                int htotal;
                double vtotal = 0;

                htotal = (tempo / 60);
                if (tempo % 60 > 0)
                    htotal++;
                if(this.tipo_veiculo == "passeio")
                    vtotal=3.5 * htotal ;
                if (this.tipo_veiculo == "utilitario")
                    vtotal = 4.5 * htotal;
                if (this.tipo_veiculo == "onibus")
                    vtotal = 7.5 * htotal;
                if (this.tipo_veiculo == "caminhao")
                    vtotal = 10 * htotal;
                return vtotal;
            }
        }
            
        static void Main()
        {
            Estacionamento meu = new Estacionamento();
            double total;
            meu.PreencherDadosVeiculo();
            meu.DadosSaida();
            total=meu.ValorAPagar(meu.CalculaTempo());
            Console.WriteLine("Total a pagar: {0}", total.ToString());
            Console.ReadKey();
        }
    }
}
